function geodynbvp1(rhoh,k,dy,yf,M,Ti,Tf)
% geodynbvp1 is a code to solve the one-dimensional, steady % state heat conduction problem for an infinite layer of
% thickness yf with constant internal heat production. The % code solves for the temperature by using a finite
% difference approximation to Equation (4-12) in
% Geodynamics subject to the boundary conditions of
% specified temperature T at the top of the layer T=Ti at
% y=0 and at the bottom of the layer T=Tf at y=yf.
% rhoh is the product of density (in kg per cubic meter)
% and the rate of internal heat production per unit mass
% (in W/kg).
% k is the thermal conductivity in units of W/m/K.
% dy is the spacing of points in the layer (in m).
% yf is the thickness of the layer in meters.
% M is the number of interior points. M, dy, and yf are
% related by (M+1)dy=yf.
% Ti(K) is the temperature at the top of the layer.
% Tf(K) is the temperature at the bottom of the layer.
C(1,1)=2;
C(1,2)=-1;
for j=[3:1:M];
C(1,j)=0;
end
MM1=M-1;
C(M,MM1)=-1;
C(M,M)=2;
MM2=M-2;
for jj=[1:1:MM2];
C(M,jj)=0;
end
for i=[2:1:MM1]
for j=[1:1:M]
C(i,j)=0;
if i==j
C(i,j)=2;
else
end
im1=i-1;
ip1=i+1;
if j==im1
C(i,j)=-1;
else
end
if j==ip1
C(i,j)=-1;
else
end
end
end
B(1,1)=((rhoh*dy*dy/k)+Ti);
B(M,1)=((rhoh*dy*dy/k)+Tf);
for n=[2:1:MM1];
B(n,1)=rhoh*dy*dy/k;
end
T=C\B
y(1)=0;
MP1=M+1;
MP2=M+2;
for i=[2:1:MP2]
    im1=i-1;
    y(i)=im1*dy;
end
TT(1)=0
for i=[2:1:MP1]
    im1=i-1;
    TT(i)=T(im1)-273;
end
TT(MP2)=1200
y
TT
plot(TT,y)






