function geodynfl1d(dy,yi,yf,Ti,q,k)
%geodynfl1d is a code to integrate Fourier's Law of Heat Conduction in one
%dimension for a constant heat flux and thermal conductivity
%input
%dy is the spatial step, yi is the initial value of y, yf is the final
%value of y, Ti is the initial value of the temperature, q is the heat
%flux, and k is the thermal conductivity. q should be in W/m^2 and k in
%(W/m/K). dy, yi, and yf should have units of m. If y is positive down and q is upward then
%q needs to be negative. If y is positive up and q is upward then q is
%positive. dy should be such that there is an integer number of steps in
%the interval yi to yf. If y is positive down and yi=0 then dy and yf are
%positive. If y is positive up and yi=0 then dy and yf are negative.
%output
%List and plot of T(y) 
n=round((yf-yi)/dy);
y=yi;
T=Ti;
TT(1)=Ti;
for i=1:n
    y=y+dy;
    T=T-(q/k)*dy;
    TT(i+1)=T;
    yy(i+1)=y;
end
TT
yy
plot(TT,yy)
end